---------------------------------------------------------------------------
-- by Protection (GUY )   渱 ѱ (http://www.inguild.com)
---------------------------------------------------------------------------

require "./AI/USER_AI/Const.lua"
require "./AI/USER_AI/Util.lua"

IN_FriendList = { }

-- ģ ߰
function AddFriend(id)
	IN_FriendList[tostring(id)] = tonumber(id);
	TraceAI( string.format("AddFriend(%s)",IN_FriendList[tostring(id)]) )
end

-- ģ 
function DelFriend(id)
	IN_FriendList[tostring(id)] = nil;
end

function SaveFriend()
	fp = io.open("AI/USER_AI/friend.ini", "w")

	if(fp == nil) then return
	end

	for k,v in pairs(IN_FriendList) do
		fp:write( string.format("%d\n", v) )
	end	

	fp:close()
end

function LoadFriend()
	for k,v in pairs(IN_FriendList) do
		IN_FriendList[k] = nil
	end

	local buf, k, v, n

	fp = io.open("AI/USER_AI/friend.ini", "r")

	if(fp == nil) then return end

	while true do
		buf = fp:read()
		if buf == nil then break end
		n = tonumber(buf)
		IN_FriendList[buf] = n
	end

	fp:close()

	SaveFriend()
end

FLAG_Friend_Add_X = 0
FLAG_Friend_Add_Y = 0
FLAG_Friend_Add = 0
FLAG_Friend_Add_Answer_X = 0
FLAG_Friend_Add_Answer_Y = 0

function Friend_Check()
	local found = 0	

	-- ģ ߰
	-- ȣ ٷ  پ ִ   ģ Ѵ.
	-- ̹ ģλ ģѴ.
	if(FLAG_Friend_Add == 1) then
		if(FLAG_Friend_Add_X == MyDestX and FLAG_Friend_Add_Y == MyDestY) then
			return 
		end

		FLAG_Friend_Add_X = 0
		FLAG_Friend_Add_Y = 0

		TraceAI("Friend_Check()")
		local users = GetUsers(MyID)
		local xd, yd;
		local x, y = MyDestX, MyDestY
		for i,v in ipairs(users) do
			x2, y2 = GetV(V_POSITION, v)
			xd = math.abs(x - x2)
			yd = math.abs(y - y2)
			TraceAI( string.format("%d %d (%d %d, %d %d)", xd, yd, x,y, x2, y2))
			if(xd <= 1 and yd <= 1) then
				found = 1
				if(IN_FriendList[tostring(v)] == nil) then
					AddFriend(v)
					FLAG_Friend_Add_Answer_X, FLAG_Friend_Add_Answer_Y = GetV(V_POSITION, GetV(V_OWNER, MyID))
					FLAG_Friend_Add_Answer_Y = FLAG_Friend_Add_Answer_Y + 1
				else
					DelFriend(v)
					FLAG_Friend_Add_Answer_X, FLAG_Friend_Add_Answer_Y = GetV(V_POSITION, GetV(V_OWNER, MyID))
					FLAG_Friend_Add_Answer_Y = FLAG_Friend_Add_Answer_Y - 1
				end
			end
		end

		if(found == 1) then
			SaveFriend()
		end
		FLAG_Friend_Add = 0
	end	
end

-- ģΰ?
function IsFriend(id)

	if(IN_FriendList[tostring(id)] ~= nil) then return true end
	return false
end